## genwqe 4.0.12

=== Makefile ===
#
# Copyright 2015, International Business Machines
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# Verbose level:
#   V=0 means completely silent
#   V=1 means brief output
#   V=2 means full output
V ?= 2

ifeq ($(V),0)
	Q		:= @
	MAKEFLAGS	+= --silent
	MAKE		+= -s
endif

ifeq ($(V),1)
	MAKEFLAGS	+= --silent
	MAKE		+= -s
endif

# VERSION string *cannot* be empty. It must be provided either in the
# version.mk file, in the command line as VERSION= or loaded by using
# the git repository information.
#
ifneq ("$(wildcard version.mk)", "")
	include ./version.mk
else
	VERSION ?= $(shell git describe --abbrev=4 --dirty --always --tags)
	RPMVERSION ?= $(shell git describe --abbrev=0 --tags)
endif

instdir = /usr
distro = $(shell lsb_release -d | cut -f2)
subdirs += lib tools
targets += $(subdirs)

UDEV_RULES_D ?= /etc/udev/rules.d
MODPROBE_D ?= /etc/modprobe.d

all: $(targets)

tools: lib

# z_ prefixed version of libz, intended to be linked statically with
# our libz version to provide the software zlib functionality.
#
ifeq ($(CONFIG_DLOPEN_MECHANISM),0)

HAS_WGET = $(shell which wget > /dev/null 2>&1 && echo y || echo n)
HAS_CURL = $(shell which curl > /dev/null 2>&1 && echo y || echo n)
OBJCOPY = @printf "\t[OBJCP]\t%s\n" `basename "$@"`; $(CROSS)objcopy

define Q
  @/bin/echo -e "	[$1]\t$(2)"
  @$(3)
endef

lib: zlib-1.2.8/libz.so

zlib-1.2.8/libz.so: zlib-1.2.8.cfg
	@/bin/echo -e "	[BUILD]\tzlib-1.2.8"
	@$(MAKE) -C zlib-1.2.8 1>&2 > /dev/null

zlib-1.2.8.cfg: zlib-1.2.8.tar.gz
	@/bin/echo -e "	[TAR]\t$<"
	@tar xfz $<
	@/bin/echo -e "	[CFG]\tzlib-1.2.8"
	@(cd zlib-1.2.8 && CFLAGS=-O2 ./configure --prefix=/opt/genwqe) \
		1>&2 > /dev/null
	@touch zlib-1.2.8.cfg

zlib-1.2.8.tar.gz:
ifeq (${HAS_WGET},y)
	$(call Q,WGET,zlib-1.2.8.tar.gz, wget -O zlib-1.2.8.tar.gz -q http://www.zlib.net/zlib-1.2.8.tar.gz)
else ifeq (${HAS_CURL},y)
	$(call Q,CURL,zlib-1.2.8.tar.gz, curl -o zlib-1.2.8.tar.gz -s http://www.zlib.net/zlib-1.2.8.tar.gz)
endif

endif

# Only build if the subdirectory is really existent
.PHONY: $(subdirs) install
$(subdirs):
	@if [ -d $@ ]; then					\
		$(MAKE) -C $@ C=0 VERSION=$(VERSION) || exit 1; \
	fi

rpmbuild_setup:
	@mkdir -p ~/rpmbuild/{BUILD,RPMS,SOURCES,SPECS,SRPMS}
	$(RM) ~/.rpmmacros
	echo '%_topdir %(echo $$HOME)/rpmbuild' >  ~/.rpmmacros

#
# Create required tar.gz archive and copy everything to the right
# places. Create version.mk since the Fedora build system requires
# running without git.
#
rpmbuild:
	@$(MAKE) -s distclean
	@echo "VERSION:=$(VERSION)" > version.mk
	@echo "RPMVERSION:=$(RPMVERSION)" >> version.mk
	@rm -rf /tmp/genwqe-$(RPMVERSION)
	@mkdir -p /tmp/genwqe-$(RPMVERSION)
	@cp -ar * /tmp/genwqe-$(RPMVERSION)/
	(cd /tmp && tar cfz genwqe-$(RPMVERSION).tar.gz genwqe-$(RPMVERSION))
	rpmbuild -ta -v --define 'srcVersion $(RPMVERSION)' \
		--define 'srcRelease 1'			\
		--define 'Version $(RPMVERSION)'	\
		/tmp/genwqe-$(RPMVERSION).tar.gz

# Install/Uninstall
install uninstall:
	@for dir in $(subdirs); do 					  \
		if [ -d $$dir ]; then					  \
			$(MAKE) -C $$dir VERSION=$(VERSION) $@ || exit 1; \
		fi							  \
	done

install_udev_rules:
	mkdir -p $(UDEV_RULES_D)
	cp etc/udev/rules.d/52-genwqedevices.rules $(UDEV_RULES_D)/

uninstall_udev_rules:
	$(RM) $(UDEV_RULES_D)/52-genwqedevices.rules

install_modprobe_d:
	mkdir -p $(MODPROBE_D)
	cp etc/modprobe.d/genwqe.conf $(MODPROBE_D)/

uninstall_modprobe_d:
	$(RM) $(MODPROBE_D)/genwqe.conf

help:
	@echo "Build GenWQE/CAPI hardware accelerator tools"
	@echo
	@echo "Possible Makefile options:"
	@echo "  V=0 silent, 1 normal (default), 2 verbose"
	@echo "  FORCE_32BIT=0 64-bit (default), 1 32-bit"
	@echo "  BUILD_SIMCODE=1 use pslse version of libcxl, 0 use libcxl "
	@echo "      (default)"
	@echo "  CONFIG_DLOPEN_MECHANISM=0 statically link against private"
	@echo "      software zlib, 1 use dlopen to include software zlib"
	@echo "      (default)"
	@echo

distclean: clean
	@$(RM) -r sim_*	zlib-1.2.8 zlib-1.2.8.tar.gz

clean:
	@for dir in $(subdirs); do 			\
		if [ -d $$dir ]; then			\
			$(MAKE) -C $$dir $@ || exit 1;	\
		fi					\
	done
	@$(RM) genwqe-$(RPMVERSION).tgz	libz.o libz_prefixed.o zlib-1.2.8.cfg
	@if [ -d zlib-1.2.8 ]; then 			\
		$(MAKE) -s -C zlib-1.2.8 distclean;	\
	fi
	@find . -depth -name '*~'  -exec rm -rf '{}' \; -print
	@find . -depth -name '.#*' -exec rm -rf '{}' \; -print

=== lib/Makefile ===
#
# Copyright 2015, International Business Machines
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

include ../config.mk

instdir ?= /usr
zlibver=1.2.8
libversion = $(VERSION)

CFLAGS += -fPIC -fno-strict-aliasing

### Accelerated libz implemenation (Accelerated Data Compression/ADC)
libname=libzADC
projA = $(libname).a $(libname)-$(libversion).so $(libname).so
src = wrapper.c hardware.c software.c
objs = __libzHW.o __libcard.o __libDDCB.o $(src:.c=.o)

### libzHW
src0 = libzHW.c inflate.c deflate.c
libname0 = libzHW
proj0 = $(libname0).a $(libname0)-$(libversion).so $(libname0).so
objs0 = $(src0:.c=.o)

### libcard
src1 = libcard.c
libname1 = libcard
proj1 = $(libname1).a $(libname1)-$(libversion).so $(libname1).so
objs1 = $(src1:.c=.o)

###libDDCB
src2 += libddcb.c ddcb_card.c

ifneq ($(CONFIG_LIBCXL_PATH),)
src2 += ddcb_capi.c
endif

libname2 = libDDCB
proj2 = $(libname2).a $(libname2)-$(libversion).so $(libname2).so
objs2 = $(src2:.c=.o)

projs += $(projA) $(proj0) $(proj1) $(proj2)

all: $(projs)

$(libcxl_a): ..check_libcxl

.PHONY: ..check_libcxl
..check_libcxl:
ifneq ($(CONFIG_LIBCXL_PATH),)
	@printf "\t[INFO]\tUsing $(libcxl_a).\n"
	@if [ ! -f $(CONFIG_LIBCXL_PATH)/include/misc/cxl.h ]; then	\
		mkdir -p $(CONFIG_LIBCXL_PATH)/include/misc/;		\
		cp ../ext/include/misc/cxl.h 				\
			$(CONFIG_LIBCXL_PATH)/include/misc/cxl.h;	\
	fi
	$(MAKE) -C $(CONFIG_LIBCXL_PATH)
	@if [ ! -f $(libcxl_a) ]; then 					\
	  printf  "\t[ERROR]\t$(libcxl_a) not found!\n"; 		\
	  echo;								\
	  echo "  Please clone libcxl git before continuing. E.g.:";	\
	  echo "    git clone https://github.com/ibm-capi/libcxl";	\
	  echo;                                                         \
	  exit 1; \
	fi
else
	# @printf "\t[INFO]\tNot using libcxl.a.\n"
endif

### libzHW
__$(libname0).o: $(objs0)
	$(LD) $(XLDFLAGS) -r -o $@ $^

$(libname0).a: __$(libname0).o
	$(AR) rcs $(ARFLAGS) $@ $^

$(libname0).so: $(libname0)-$(libversion).so
	ln -sf $< $@

$(libname0)-$(libversion).so: __$(libname0).o
	$(CC) $(LDFLAGS) -shared -Wl,-soname,$@ -o $@ $^

### libcard
__$(libname1).o: $(objs1)
	$(LD) $(XLDFLAGS) -r -o $@ $^

$(libname1).a: __$(libname1).o
	$(AR) rcs $(ARFLAGS) $@ $^

$(libname1).so: $(libname1)-$(libversion).so
	ln -sf $< $@

$(libname1)-$(libversion).so: __$(libname1).o
	$(CC) $(LDFLAGS) -shared -Wl,-soname,$@ -o $@ $^

### libDDCB
__$(libname2).o: $(objs2) $(libcxl_a)
	$(LD) $(XLDFLAGS) -r -o $@ $^

$(libname2).a: __$(libname2).o
	$(AR) rcs $(ARFLAGS) $@ $^

$(libname2).so: $(libname2)-$(libversion).so
	ln -sf $< $@

$(libname2)-$(libversion).so: __$(libname2).o
	$(CC) $(LDFLAGS) -shared -Wl,-soname,$@ -o $@ $^

### libzADC
__$(libname).o: $(objs) $(libz_a)
	$(LD) $(XLDFLAGS) -r -o $@ $^

$(libname).a: __$(libname).o
	$(AR) rcs $@ $^

$(libname).so: $(libname)-$(libversion).so
	ln -sf $< $@

$(libname)-$(libversion).so: __$(libname).o
	$(CC) $(LDFLAGS) -shared -Wl,-soname,$@ \
		 -Wl,--version-script=libzADC.map -o $@ $^

# Produce z_ prefixed verson of software zlib. We need this when we
# want to include libz statially instead of using dlopen/dlsym to use
# it.
#
# Special version of libz.a which has z_ prefixed function
# names. Required for software zlib fallback in case of small buffers
# and accelerator unavailability.
#
libz_prefixed.o:

zlib_objs = $(CONFIG_LIBZ_PATH)/adler32.lo  \
	    $(CONFIG_LIBZ_PATH)/infback.lo  \
	    $(CONFIG_LIBZ_PATH)/compress.lo \
	    $(CONFIG_LIBZ_PATH)/gzclose.lo  \
	    $(CONFIG_LIBZ_PATH)/inffast.lo  \
	    $(CONFIG_LIBZ_PATH)/trees.lo    \
	    $(CONFIG_LIBZ_PATH)/crc32.lo    \
	    $(CONFIG_LIBZ_PATH)/gzlib.lo    \
	    $(CONFIG_LIBZ_PATH)/inflate.lo  \
	    $(CONFIG_LIBZ_PATH)/uncompr.lo  \
	    $(CONFIG_LIBZ_PATH)/deflate.lo  \
	    $(CONFIG_LIBZ_PATH)/gzread.lo   \
	    $(CONFIG_LIBZ_PATH)/inftrees.lo \
	    $(CONFIG_LIBZ_PATH)/zutil.lo    \
	    $(CONFIG_LIBZ_PATH)/gzwrite.lo

libz_prefixed.o: libz.o
	$(OBJCOPY) --prefix-symbols=z_ $< $@

libz.o: $(CONFIG_LIBZ_PATH)/libz.so
	$(LD) $(XLDFLAGS) -r -o $@ $(zlib_objs)

install: install_zlib

install_zlib: all
	mkdir -p $(instdir)/lib/genwqe
	cp -uv $(projA) $(instdir)/lib/genwqe/
	(cd $(instdir)/lib/genwqe/ && \
		ln -sf $(libname).a libz.a && \
		ln -sf $(libname)-$(libversion).so libz.so && \
		ln -sf $(libname)-$(libversion).so libz.so.1)
	mkdir -p $(instdir)/include/genwqe
	cp -uv ../include/zaddons.h $(instdir)/include/genwqe/

uninstall:
	@echo "removing $(instdir)/include/genwqe $(instdir)/lib/genwqe"
	$(RM) -r $(instdir)/include/genwqe $(instdir)/lib/genwqe

# general things
%.o: %.c
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@
	$(CC) -MM $(CPPFLAGS) $(CFLAGS) $< > $*.d

clean distclean:
	$(RM) *.o *.d $(projs) *.so
ifneq ($(CONFIG_LIBCXL_PATH),)
	$(MAKE) -C $(CONFIG_LIBCXL_PATH) $@
endif

-include $(objs:.o=.d) $(objs0:.o=.d) $(objs1:.o=.d) $(objs2:.o=.d)

=== tools/Makefile ===
#
# Copyright 2015, International Business Machines
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

include ../config.mk

instdir ?= /usr
libs = ../lib/libDDCB.a ../lib/libzHW.a ../lib/libcard.a $(libcxl_a) # static
LDLIBS += $(libs) -lpthread -lrt                                     # dynamic

genwqe_peek_objs = force_cpu.o
genwqe_poke_objs = force_cpu.o
genwqe_memcopy_objs = force_cpu.o
genwqe_cksum_objs = force_cpu.o
genwqe_echo_objs = force_cpu.o
genwqe_vpdupdate_objs = genwqe_vpd_common.o
genwqe_vpdconv_objs = genwqe_vpd_common.o

genwqe_memcopy_libs = -lz
genwqe_cksum_libs = -lz
genwqe_gzip_libs = ../lib/libzADC.a -ldl	# statically link our libz
genwqe_gunzip_libs = ../lib/libzADC.a -ldl	# statically link our libz
zlib_mt_perf_libs = ../lib/libzADC.a -ldl	# statically link our libz

projs = genwqe_update genwqe_gzip genwqe_gunzip zlib_mt_perf genwqe_memcopy \
	genwqe_echo genwqe_peek genwqe_poke genwqe_cksum \
	genwqe_vpdconv genwqe_vpdupdate csv2bin genwqe_loadtree genwqe_ffdc

# Do this only on platforms where we have a libcxl available e.g. System p
ifneq ($(CONFIG_LIBCXL_PATH),)
projs += genwqe_maint
endif

all: $(projs)

genwqe_memcopy: force_cpu.o
genwqe_vpdconv genwqe_vpdupdate: genwqe_vpd_common.o

$(projs): $(libs)

objs = force_cpu.o genwqe_vpd_common.o $(projs:=.o)

manpages = $(projs:=.1)

manpages: all $(manpages)

genwqe_gunzip.o: genwqe_gzip.c
	$(CC) -c $< $(CPPFLAGS) $(CFLAGS) -o $@

### Deactivate existing implicit rule
%: %.c
%: %.sh

### Generic rule to build a tool
%: %.o
	$(CC) $(LDFLAGS) $@.o $($(@)_objs) $($(@)_libs) $(LDLIBS) -o $@

%.o: %.c $(libs)
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@
	$(CC) -MM $(CPPFLAGS) $(CFLAGS) $< > $*.d

%.1: %
	$(HELP2MAN) -N --output=$@ --name "IBM Hardware Accelerator Tool." ./$<

#
# Tools for card maintenance
#
install_release_tools: all
	@mkdir -p $(instdir)/bin
	cp -uv genwqe_peek genwqe_poke genwqe_memcopy genwqe_echo genwqe_update \
		$(instdir)/bin

#
# Example tools and testcases
#   gzip and gunzip go into special directory, since they should not be
#   in regular path to be mixed up with distro version of those tools.
#   Nevertheless we need them to accelerate tar for example with our
#   hardware accelerated version of gzip/gunzip.
#
install_gzip_tools: all
	mkdir -p $(instdir)/bin/genwqe
	cp -uv genwqe_gzip $(instdir)/bin/genwqe/gzip
	cp -uv genwqe_gzip $(instdir)/bin/genwqe/gunzip
	cp -uv zlib_mt_perf zlib_mt_perf.sh zlib_test_gz.sh $(instdir)/bin

uninstall_gzip_tools:
	$(RM) $(instdir)/bin/genwqe/gzip	\
	      $(instdir)/bin/genwqe/gunzip	\
	      $(instdir)/bin/zlib_mt_perf	\
	      $(instdir)/bin/zlib_mt_perf.sh	\
	      $(instdir)/bin/zlib_test_gz.sh

install_manpages: $(manpages)
	@mkdir -p $(instdir)/man/man1
	cp -uv $(manpages) $(instdir)/man/man1

install_release_manpages: $(manpages)
	@mkdir -p $(instdir)/man/man1
	cp -uv genwqe_memcopy.1 genwqe_echo.1 genwqe_update.1 \
		$(instdir)/man/man1

uninstall_manpages:
	@for f in $(manpages) ; do				\
		echo "removing $(instdir)/man/man1/$$f ...";	\
		$(RM) $(instdir)/man/man1/$$f;			\
	done

install: install_gzip_tools install_manpages
	@mkdir -p $(instdir)/bin
	cp -uv $(projs) $(instdir)/bin

uninstall: uninstall_gzip_tools uninstall_manpages
	@for f in $(projs) ; do					\
		echo "removing $(instdir)/bin/$$f ...";		\
		$(RM) $(instdir)/bin/$$f;			\
	done

clean distclean:
	$(RM) $(objs) $(projs) $(objs:.o=.d) $(manpages)

-include $(objs:.o=.d)

=== debian/changelog ===
genwqe (4.0.12-0ubuntu3) xenial; urgency=high

  * Disable libcxl on ppc64el, not packaged.
  * Remove un-used header file.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 04 Mar 2016 11:38:17 +0000

genwqe (4.0.12-0ubuntu2) xenial; urgency=medium

  * Add missing build-dependency on zlib1g-dev.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 17 Feb 2016 13:01:59 +0000

genwqe (4.0.12-0ubuntu1) xenial; urgency=medium

  * Initial release LP: #1542371.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 16 Feb 2016 13:20:45 +0000

=== debian/control ===
Source: genwqe
Priority: optional
Maintainer: Dimitri John Ledkov <xnox@ubuntu.com>
Build-Depends: debhelper (>=9), help2man, zlib1g-dev
Standards-Version: 3.9.6
Section: libs
Homepage: https://github.com/ibm-genwqe/genwqe-user/releases

Package: libzadc-dev
Section: libdevel
Architecture: any
Depends: libzadc1 (= ${binary:Version}), ${misc:Depends}
Description: accelerated libz implementation (development headers)
 Accelerated libz implementation uses FPGA based PCIe cards
 (e.g. zEDC) to accelerate compression/decompression.
 .
 This package provides headers and development libraries.

Package: libzadc1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: accelerated libz implementation (Accelerated Data Compression/ADC)
 Accelerated libz implementation uses FPGA based PCIe cards
 (e.g. zEDC) to accelerate compression/decompression.
 .
 This package provides public libzADC library, and libz library
 symlinks which are not exposed in the ldconfig paths.

Package: genwqe
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: utilities for accelerated libz implementation
 Accelerated libz implementation uses FPGA based PCIe cards
 (e.g. zEDC) to accelerate compression/decompression.
 .
 This package provides utilities to use libzADC, as well as
 gzip/gunzip names for genwqe utilities in a subdirectory not in
 $PATH.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk

vars=VERSION=$(DEB_VERSION_UPSTREAM) CONFIG_ZLIB_PATH=/lib/$(DEB_HOST_MULTIARCH)/libz.so.1 V=2 libdir=/lib/$(DEB_HOST_MULTIARCH)

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean -- $(vars)

override_dh_auto_build:
	dh_auto_build -- $(vars)

override_dh_auto_install:
	dh_auto_install -- $(vars)
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/genwqe/
	ln -s /lib/$(DEB_HOST_MULTIARCH)/libzADC.so.1 debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libzADC.so
	ln -s /lib/$(DEB_HOST_MULTIARCH)/genwqe/libz.so.1 debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/genwqe/libz.so
	find debian/tmp -name '*.sh' -delete
	mkdir -p debian/tmp/usr/lib/
	mv debian/tmp/usr/bin/genwqe debian/tmp/usr/lib/ 

override_dh_auto_test:

override_dh_install:
	dh_install --list-missing
